// paracalc.cpp : AvP[ṼGg |Cg`܂B
//

#include <windows.h>
#include <tchar.h>
#include "paracalc.h"
#include "calc.h"
#include "regex.h"

#define RESULT_SIZE 1024

struct {
	bool IsShowMessageBox;
	bool IsSaveClipboard;
} gOptions;

bool mIsComfirm = false;

// IvVp[XB
void ParseOption(LPTSTR &lpCmdLine) {
	gOptions.IsShowMessageBox = false;
	gOptions.IsSaveClipboard = false;

	CRegex re;
	re.SetIgnoreCase(TRUE);
	re.SetPattern(_T("^\\s*(/(\\w)(:(\\S+))?)"));
	while (re.Search(lpCmdLine) > 0) {
		LPTSTR opt = re.GetMatch(2);
		if (_tcsicmp(opt, _T("m")) == 0) {
			//bZ[W_CAO\
			gOptions.IsShowMessageBox = true;
		} else if (_tcsicmp(opt, _T("c")) == 0) {
			//Nbv{[hɕۑ
			gOptions.IsSaveClipboard = true;
		}

		lpCmdLine = re.GetNext();
	}

	//ǂfalseȂAbZ[W_CAO\
	if (!gOptions.IsShowMessageBox && !gOptions.IsSaveClipboard) {
		gOptions.IsShowMessageBox = true;
	}
}

// bZ[W\
void DisplayMessage(LPCTSTR message) {
	MessageBox(NULL, message, _T("ParaCalc"), MB_OK);
}

// Nbv{[hɕۑ
void SaveClipboard(LPCTSTR message) {
	HGLOBAL hText = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE, sizeof(TCHAR) * (_tcslen(message) + 1));
	LPTSTR lpClipboard = (LPTSTR) GlobalLock(hText);
	_tcscpy(lpClipboard, message);
	GlobalUnlock(hText);

	OpenClipboard(NULL);
	EmptyClipboard();
	SetClipboardData(CF_UNICODETEXT, hText);
	CloseClipboard();
}

// C
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	bool ret = false;

	//IvṼp[X
	ParseOption(lpCmdLine);

	//vZ
	TCHAR result[RESULT_SIZE] = {0};
	if (!Calc(lpCmdLine, result, RESULT_SIZE)) {
		DisplayMessage(result);
		return 1;
	}

	//_CAO\
	if (gOptions.IsShowMessageBox) {
		DisplayMessage(result);
	}

	//Nbv{[hۑ
	if (gOptions.IsSaveClipboard) {
		SaveClipboard(result);
	}

	return 0;
}
